
<p><em>Koder</em> je kombinacijski sklop koji provodi operaciju kodiranja u zadanom kodu. Prisjetite se kako smo definirali kod: to je bijektivno preslikavanje iz domene koju čini skup simbola u kodomenu koju čine kodne riječi. U digitalnim sustavima, kodne riječi su binarni uzorci.</p>

<p>Ako domena sadrži <i>n</i> simbola, koder će imati <i>n</i>-bitovni ulaz na koji se dovodi binarni uzorak koji ima samo jedan bit postavljen u vrijednost 1. Primjerice, neka imamo kod čija domena sadrži 4 simbola. Označimo ih s I<sub>0</sub>, I<sub>1</sub>, I<sub>2</sub> i I<sub>3</sub>. 
   Tada će koder imati četiribitni ulaz, koji ćemo označiti s I<sub>3</sub>I<sub>2</sub>I<sub>1</sub>I<sub>0</sub>. Ako na taj ulaz dovedemo binarni uzorak 0001 (jedinica je na mjestu I<sub>0</sub>), tražimo od kodera da na svojim izlazima generira kodnu riječ koju kod pridjeljuje simbolu I<sub>0</sub>.
   0010 na ulazu će tražiti da se na izlazu generira kodna riječ kojom je kodiran simbol I<sub>1</sub>, 0100 na ulazu će tražiti da se na izlazu generira kodna riječ kojom je kodiran simbol I<sub>2</sub> a 1000 na ulazu će tražiti da se na izlazu generira kodna riječ kojom je kodiran simbol I<sub>2</sub>.</p>

<p>U nastavku ćemo prikazati nekoliko često korištenih kodera.</p>

<h3><i>n</i>-bitni binarni koder</h3>

<p>Ovo je koder za prirodni binarni kod čiju domenu čine simboli koji su brojevi od 0 do 2<sup>n</sup>-1 a kodomenu čine kodne riječi koje broju <i>k</i> pridjeljuju <i>n</i>-bitni binarni zapis tog broja u prirodnom binarnom kodu. Za primjer <i>n</i>=3, takav je kod prikazan na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(nbc-kod-3-hr.svg)" alt="Trobitni prirodni binarni kod"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Trobitni prirodni binarni kod.</figcaption>
</figure>

<script>
@#page-include#(canvas.js)
@#page-include#(util.js)
@#page-include#(basic-coder.js)
</script>

<p>Interaktivna simulacija ovog kodera dana je u nastavku. Klikom miša na ulaze kodera s lijeve strane možete odabrati na koji će ulaz biti dovedena jedinica; svi ostali ulazi automatski će biti postavljeni na nulu.
Pogledajte kako se mijenjaju izlazi ovog kodera u ovisnosti o ulazima. Kodna riječ generira se na izlazima A<sub>2</sub>A<sub>1</sub>A<sub>0</sub>.</p>

<div style="text-align: center;">
<canvas id="canvasNBC" width="170" height="420" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autori simulacije: Arijana Brlek, Nino Uzelac</span>
</div>

<script>
  @#page-include#(binary-coder.js)
  var coderinfo1 = setupCoder("canvasNBC", new BinaryCoder(3));
  coderinfo1.coder.draw(coderinfo1.canvas, coderinfo1.context);
</script>

<h3><i>n</i>-bitni Grayev koder</h3>

<p>Ovo je koder za Grayev kod čiju domenu čine simboli koji su brojevi od 0 do 2<sup>n</sup>-1 a kodomenu čine kodne riječi koje broju <i>k</i> pridjeljuju <i>n</i>-bitni binarni zapis tog broja u Grayevom kodu. Za primjer <i>n</i>=3, takav je kod prikazan na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(gray-kod-3-hr.svg)" alt="Trobitni Grayev kod"><br>
<figcaption><span class="mlFigKey">Slika 2.</span> Trobitni Grayev kod.</figcaption>
</figure>

<p>Interaktivna simulacija ovog kodera dana je u nastavku. Klikom miša na ulaze kodera s lijeve strane možete odabrati na koji će ulaz biti dovedena jedinica; svi ostali ulazi automatski će biti postavljeni na nulu.
Pogledajte kako se mijenjaju izlazi ovog kodera u ovisnosti o ulazima. Kodna riječ generira se na izlazima A<sub>2</sub>A<sub>1</sub>A<sub>0</sub>.</p>

<div style="text-align: center;">
<canvas id="canvasGRAY" width="170" height="420" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autori simulacije: Arijana Brlek, Nino Uzelac</span>
</div>

<script>
  @#page-include#(gray-coder.js)
  var coderinfo2 = setupCoder("canvasGRAY", new GrayCoder(3));
  coderinfo2.coder.draw(coderinfo2.canvas, coderinfo2.context);
</script>

<h3>BCD-koder</h3>

<p>Ovo je koder za BCD-kod čiju domenu čine simboli koji su dekadske znamenke a kodomenu čine kodne riječi koje znamenci <i>k</i> pridjeljuju <i>4</i>-bitni binarni zapis te znamenke u kodu BCD. Kod je prikazan na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(bcd-kod-hr.svg)" alt="BCD-kod"><br>
<figcaption><span class="mlFigKey">Slika 3.</span> BCD-kod.</figcaption>
</figure>

<p>Interaktivna simulacija ovog kodera dana je u nastavku. Klikom miša na ulaze kodera s lijeve strane možete odabrati na koji će ulaz biti dovedena jedinica; svi ostali ulazi automatski će biti postavljeni na nulu.
Pogledajte kako se mijenjaju izlazi ovog kodera u ovisnosti o ulazima. Kodna riječ generira se na izlazima A<sub>3</sub>A<sub>2</sub>A<sub>1</sub>A<sub>0</sub>.</p>

<div style="text-align: center;">
<canvas id="canvasBCD" width="170" height="420" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autori simulacije: Arijana Brlek, Nino Uzelac</span>
</div>

<script>
  @#page-include#(bcd-coder.js)
  var coderinfo3 = setupCoder("canvasBCD", new BCDCoder());
  coderinfo3.coder.draw(coderinfo3.canvas, coderinfo3.context);
</script>

<h3>Excess-3-koder</h3>

<p>Ovo je koder za Excess-3-kod čiju domenu čine simboli koji su dekadske znamenke a kodomenu čine kodne riječi koje znamenci <i>k</i> pridjeljuju <i>4</i>-bitni binarni zapis te znamenke u kodu Excess-3. Kod je prikazan na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(ex3-kod-hr.svg)" alt="Excess-3-kod"><br>
<figcaption><span class="mlFigKey">Slika 4.</span> Excess-3-kod.</figcaption>
</figure>

<p>Interaktivna simulacija ovog kodera dana je u nastavku. Klikom miša na ulaze kodera s lijeve strane možete odabrati na koji će ulaz biti dovedena jedinica; svi ostali ulazi automatski će biti postavljeni na nulu.
Pogledajte kako se mijenjaju izlazi ovog kodera u ovisnosti o ulazima. Kodna riječ generira se na izlazima A<sub>3</sub>A<sub>2</sub>A<sub>1</sub>A<sub>0</sub>.</p>

<div style="text-align: center;">
<canvas id="canvasEx3" width="170" height="420" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autori simulacije: Arijana Brlek, Nino Uzelac</span>
</div>

<script>
  @#page-include#(excess3-coder.js)
  var coderinfo4 = setupCoder("canvasEx3", new Excess3Coder());
  coderinfo4.coder.draw(coderinfo4.canvas, coderinfo4.context);
</script>

<h3>Specifičnosti kodera</h3>

<p>Odabir simbola čiji kod koder treba generirati na izlazu tipično se obavlja dovođenjem binarnog uzorka posebnog oblika na ulaz kodera. Taj binarni uzorak je takav da smije samo na jednom mjestu imati bit postavljen na jedan; svi ostali bitovi moraju biti postavljeni na nulu. Takvi <i>n</i>-bitni binarni uzorci tvore <i>n</i>-bitni <em>jednojedinični kod</em> (engleski termin je <i>1-hot encoding</i>).
   Situacija u kojoj je više bitova postavljeno u vrijednost 1 ili pak niti jedan bit, za kodere predstavlja problem. Taj se problem riješava konstrukcijom <em>prioritetnih kodera</em> o kojima će biti riječi na predavanju.</p>
